#pragma once

#include <type_traits>

#include <amdis/assembler/FirstOrderTestGradTrial.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct gradtest_trial {};
  }


  /// first-order operator \f$ \langle\nabla\psi, \mathbf{b}\,\phi\rangle \f$
  template <class LocalContext, class GridFct>
  class GridFunctionOperator<tag::gradtest_trial, LocalContext, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::gradtest_trial, LocalContext, GridFct>,
                                              GridFunctionOperator<tag::test_gradtrial, LocalContext, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::test_gradtrial, LocalContext, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::gradtest_trial, GridFct const& expr)
      : Super(tag::test_gradtrial{}, expr)
    {}
  };

  /** @} **/

} // end namespace AMDiS
